      PROGRAM EX0205
      DATA P,W1,W2,W3,W4/0.10133,30.87,-1.285E-2,2.789E-5,-1.272E-8/
      WRITE (*,1000)
 1000 FORMAT(2X,'TEMPERATURE     CP        CV    ENTHALPY   ENTROPY',
     &/,1X,'     [K]          [J/MOL/K]      [J/MOL]   [J/MOL/K]',
     &/,2X,'----------------------------------------------------')
      DO 100 T=300,1200,300
      CALL PRFGAS(T,P,W1,W2,W3,W4,PGH,PGS,PGCV,PGCP)
  100 WRITE (*,1020) T,PGCP,PGCV,PGH,PGS
 1020 FORMAT(1X,5F10.2)
      END


      SUBROUTINE PRFGAS
     &(T,P,W1,W2,W3,W4,PGH,PGS,PGCV,PGCP)
C
C     The Subroutine calculates the Perfect-gas properties:
C       1) Constant-volume molar Heat Capacity   (PGCV)  in [J/mol/K]
C       2) Constant-pressure molar Heat Capacity (PGCV)  in [J/mol/K]
C       3) molar Entropy                          (PGS)  in [J/mol/K]
C       4) molar Enthalpy                         (PGH)  in   [J/mol]
C     as a function of Temperature, T in [K], and Pressure, P in [MPa],
C     from the molar Perfect-gas Constant-Pressure Heat Capacity
C     coefficients,
C     PGCP=W1+W2*T+W3*(T**2)+W4*(T**3) in [J/mol/K]
C
C     - Enthalpy and Entropy are arbitrarily assumed to be equal to ZERO
C       at 273.15 K and 0.10133 MPa.
C
      T0=273.15
      P0=0.10133
      R=8.31451
      PGCP=W1+W2*T+W3*T*T+W4*(T**3)
      PGCV=PGCP-R
      PGH=W1*(T-T0)+W2*((T**2)-(T0**2))/2.+W3*((T**3)-(T0**3))/3.
     &+W4*((T**4)-(T0**4))/4.
      PGS=W1*LOG(T/T0)+W2*(T-T0)+W3*((T**2)-(T0**2))/2.
     &+W4*((T**3)-(T0**3))/3.-R*LOG(P/P0)
      RETURN
      END
