      PROGRAM EX0705
      PARAMETER (IC=3)
      DIMENSION GR(IC,IC),AIJ(IC,IC),X(IC),G(IC)
      DATA GR(1,1),GR(1,2),GR(1,3)/   0.  ,162.04,1263.07/
      DATA GR(2,1),GR(2,2),GR(2,3)/ 151.47,  0.  ,  44.28/
      DATA GR(3,1),GR(3,2),GR(3,3)/ 671.80,491.14,   0.  /
      DATA AIJ/9*0.3/
      AIJ(1,3)=0.4
      AIJ(3,1)=0.4
      DATA X,T/0.30,0.10,0.60,343.15/
C
      CALL NRTL(IC,X,T,GR,AIJ,G)
      WRITE(*,1000) G(1),G(2),G(3)
 1000 FORMAT(3X,'G1 =',F6.3,5X,'G2 =',F6.3,5X,'G3 =',F6.3)
      STOP
      END



	SUBROUTINE NRTL(IC,X,T,GR,AIJ,G)
C
C     The subroutine calculates activity coefficients G(I) for the
C     NRTL model, for a mixture at temperature T [K], of IC components
C     each of molefraction X(I).
C     Other input required is
C     - GR (I,J) : g(I,J)/R  and
C     - AIJ(I,J) : NRTL parameter a12 for binary mixture of I and J
C
      DIMENSION X(IC),GR(IC,IC),AIJ(IC,IC),G(IC)
      DIMENSION GC(5,5),TA(5,5)
      DO 100 I=1,IC
      DO 100 J=1,IC
      TA(I,J)=GR(I,J)/T
  100 GC(I,J)=EXP(-AIJ(I,J)*TA(I,J))
      DO 500 I=1,IC
      STXG=0.
      SXG=0.
      DO 200 K=1,IC
      STXG=STXG+TA(K,I)*X(K)*GC(K,I)
  200 SXG=SXG+X(K)*GC(K,I)
      G11=STXG/SXG
      S2PART=0.
      DO 400 J=1,IC
      SXG=0.
      SXTG=0.
      DO 300 K=1,IC
      SXG=SXG+X(K)*GC(K,J)
  300 SXTG=SXTG+X(K)*TA(K,J)*GC(K,J)
  400 S2PART=S2PART+(X(J)*GC(I,J)/SXG)*(TA(I,J)-(SXTG/SXG))
  500 G(I)=EXP(G11+S2PART)
      RETURN
      END
