      PROGRAM EX0805
      PARAMETER (IS=2)
      DIMENSION X(IS),Y(IS),PSAT(IS),EK(IS),FPUR(IS),F(IS),G(IS)
      DIMENSION TC(IS,IS),PC(IS,IS),DC(IS),OMEG(IS,IS),VP(IS,3)
      DIMENSION SLR(IS,IS),V(IS,IS),DD(IS),BK(IS,IS),YY(4)
      DATA (TC  (J,J),J=1,IS)/513.88,562.06/
      DATA (PC  (J,J),J=1,IS)/6.132E+6,4.895E+6/
      DATA (DC  (J)  ,J=1,IS)/5984.4,3861.0/
      DATA (OMEG(J,J),J=1,IS)/0.644,0.212/
      DATA (SLR (1,I),I=1,IS)/ 0.,653.13/
      DATA (SLR (2,I),I=1,IS)/66.16,0./
      DATA (VP  (1,I),I=1,3)/7.24222,1595.811,-46.702/
      DATA (VP  (2,I),I=1,3)/6.01905,1204.637,-53.081/
      DATA BK(1,1),BK(1,2),BK(2,1),BK(2,2)/0.,0.,0.,0./
      DATA ITP,T,PAPR/2,353.,0.15E+6/        
      DATA (YY (J)  ,J=1,4)/0.,0.,0.,0./
      DATA X(1),X(2)/1.,0./
C
C     MOLAR VOLUMES CALCULATION
C
      CALL BWR
     &(T,PAPR,1,1,X(1),TC(1,1),DC(1),OMEG(1,1),YY(1),YY(2),YY(3),
     &YY(4),BK(1,1),DD(1),H,S,FUG)
      CALL BWR
     &(T,PAPR,1,1,X(1),TC(2,2),DC(2),OMEG(2,2),YY(1),YY(2),YY(3),
     &YY(4),BK(2,2),DD(2),H,S,FUG)
      WRITE (*,1000)
 1000 FORMAT(7X,'P [MPA]',6X,'X(1)',6X,'X(2)',10X,'Y(1)',6X,'Y(2)',8X,
     &'K(1)/K(2)')
      DO 20 I=1,IS
      DO 20 J=1,IS
   20 V(I,J)=(1./DD(I))/(1./DD(J))
      DO 40 K=1,9
      X(1)=0.1*FLOAT(K)
      X(2)=1.-X(1)
      WLO=0.05E+6
      WHI=0.30E+6
      CALL BUBLVW
     &(IS,P,T,ITP,WLO,WHI,X,Y,TC,PC,OMEG,SLR,V,PSAT,EK,FPUR,F,G,VP)

   40 WRITE (*,1100) P*1.E-6,X(1),X(2),Y(1),Y(2),EK(1)/EK(2)
 1100 FORMAT(5X,F8.3,4X,2(F8.4,2X),4X,2(F8.4,2X),4X,F8.4)
      END


      SUBROUTINE BUBLVW
     &(IS,P,T,ITP,WLO,WHI,X,Y,TC,PC,OMEG,SLR,V,PSAT,EK,FPUR,F,G,VP)
C
C     The subroutine calculates vapour molefractions Y(I) of a mixture
C     of IS components, and
C     a) ITP=1, finds bubble-point temperature T in [K],
C               given the pressure P in [Pa], or
C     b) ITP=2, finds bubble-point pressure P in [MPa],
C               given the temperature T in [K].
C        Method adopted is based on:
C     1. Activity coeficients, G(I),(supplied by another subroutine
C        say TKWILSON), and
C     2. Virial equation truncated to second coefficient (Tsonopoulos
C        expressions with Lorentz-Berthelot mixing rules).
C     -  Addiotional input to the subroutine are liquid molefractions
C     X(I), critical constants TC(I,I) in [K], and PC(I,I) in [Pa]
C     acentric factor OMEG(I,I), and Antoine equation coeffs. VP(IS,3).
C        Also first and last value, WLO and WHI, for the temperature or
C     pressure iteration must be provide.
C     -  Output includes vapour pressure PSAT(I), equilibrium constant
C     EK(I),pure fugacity coef.FPUR(I) and component fugacity coef.F(I).
C
      DIMENSION X(IS),Y(IS),PSAT(IS),EK(IS),FPUR(IS),F(IS),G(IS)
      DIMENSION TC(IS,IS),PC(IS,IS),OMEG(IS,IS),VP(IS,3)
      DIMENSION SLR(IS,IS),V(IS,IS)
      DIMENSION B(10,10),VC(10,10),ZC(10,10)
      R=8.3145
C
C     Mixture Critical TC(I,J), PC(I,J) (Lorentz-Berthelot Mixing Rules)
C
      DO 100 I=1,IS
  100 VC(I,I)=(0.291-0.080*OMEG(I,I))*R*TC(I,I)/PC(I,I)
      DO 120 I=1,IS
      DO 120 J=1,IS
      OMEG(I,J)=(OMEG(I,I)+OMEG(J,J))/2.
      ZC(I,J)=0.291-0.080*OMEG(I,J)
      VC(I,J)=(1./8.)*((VC(I,I)**(1./3.))+(VC(J,J)**(1./3.)))**3
      TC(I,J)=SQRT(TC(I,I)*TC(J,J))
  120 PC(I,J)=ZC(I,J)*R*TC(I,J)/VC(I,J)
C
C     Activity Coef. G(I), Virial Coef. B(I,J) (Tsonopoulos Equations)
C
   10 PROP=(WLO+WHI)/2.
      IF (ITP.EQ.1) T=PROP
      IF (ITP.EQ.2) P=PROP
C      WRITE(*,*) PROP
      CALL TKWILSON(IS,X,T,SLR,V,G,1)
      DO 140 I=1,IS
      DO 140 J=1,IS
      TRI=TC(I,J)/T
  140 B(I,J)=R*TC(I,J)/PC(I,J)*(0.1445-0.33*TRI-0.1385*(TRI**2)-0.0121*
     &(TRI**3)-0.000607*(TRI**8)+OMEG(I,J)*(0.0637+0.331*(TRI**2)-0.423*
     &(TRI**3)-0.008*(TRI**8)))
C
C     First Y(I)'s
C
      S1=0.
      DO 160 J=1,IS
      FPUR(J)=EXP(B(J,J)*P/R/T)
      PSAT(J)=1000.*(10.**(VP(J,1)-VP(J,2)/(T+VP(J,3))))
      Y(J)=G(J)*PSAT(J)*FPUR(J)/P
  160 S1=S1+Y(J)
      DO 180 J=1,IS
  180 Y(J)=Y(J)/S1
C
C     Pure Fugacity Coef. FPUR(I), Comp.Fugacity Coef. F(I),
C     Sat.Pressure PSAT(I), Equil.Constant EK(I), & Y(I)s
C
   20 BMIX=0.
      DO 200 I=1,IS
      DO 200 J=1,IS
  200 BMIX=BMIX+Y(I)*Y(J)*B(I,J)
      SY=0.
      DO 240 I=1,IS
      FTERM=0.
      DO 220 K=1,IS
  220 FTERM=FTERM+Y(K)*B(K,I)
      F(I)=EXP(P/R/T*(2.*FTERM-BMIX))
      FPUR(I)=EXP(B(I,I)*P/R/T)
      PSAT(I)=1000.*(10.**(VP(I,1)-VP(I,2)/(T+VP(I,3))))
      EK(I)=G(I)*FPUR(I)*PSAT(I)/(P*F(I))
      Y(I)=EK(I)*X(I)
  240 SY=SY+Y(I)
      DO 260 I=1,IS
  260 Y(I)=Y(I)/SY
      IF (ABS(SY-S1).LE.0.000001) GOTO 30
      S1=SY
      GOTO 20
C
C     TEMPERATURE (IPT=1) OR PRESSURE (IPT=2) ITERATION
C
   30 IF (SY.GE.0.99995.AND.SY.LE.1.00005) GOTO 40
      IF (ITP.EQ.1.AND.SY.GT.1.00005) WHI=T
      IF (ITP.EQ.1.AND.SY.LT.0.99995) WLO=T
      IF (ITP.EQ.2.AND.SY.GT.1.00005) WLO=P
      IF (ITP.EQ.2.AND.SY.LT.0.99995) WHI=P
      GOTO 10
   40 RETURN
      END


      SUBROUTINE TKWILSON(IS,X,T,SLR,V,G,IOPT)
C
C     The subroutine calculates activity coefficients G(I) for the
C     Wilson (IOPT=1) and the T-K-Wilson (IOPT=2) models, for a mixture
C     at temperature T [K], of IS components each of molefraction X(I).
C     Other input required is
C     - SLR(I,J) : lamda(I,J)/R and
C     -  V (I,J) : molar volume of J / molar volume of I.
C
      DIMENSION X(IS),SLR(IS,IS),V(IS,IS),G(IS)
      DIMENSION AL(5,5),VV(5,5)
      DO 100 I=1,IS
      DO 100 J=1,IS
      AL(I,J)=V(J,I)*EXP(-SLR(I,J)/T)
      IF (IOPT.EQ.1) VV(J,I)=1.
  100 IF (IOPT.EQ.2) VV(J,I)=V(J,I)
      DO 500 I=1,IS
      SXV=0.
      SXL=0.
      DO 200 J=1,IS
      SXV=SXV+X(J)*VV(I,J)
  200 SXL=SXL+X(J)*AL(I,J)
      G11=LOG(SXV/SXL)
      SXK=0.
      DO 400 K=1,IS
      SXV=0.
      SXL=0.
      DO 300 J=1,IS
      SXV=SXV+X(J)*VV(K,J)
  300 SXL=SXL+X(J)*AL(K,J)
  400 SXK=SXK+X(K)*((VV(K,I)/SXV)-(AL(K,I)/SXL))
  500 G(I)=EXP(G11+SXK)
      RETURN
      END


      SUBROUTINE BWR
     &(T,P,IP,IS,X,TC,DC,OMEG,Y1,Y2,Y3,Y4,BK,D,H,S,FUG)
C
C     The subroutine calculates the following thermodynamic properties
C     of mixtures, as a function of temperature, T in [K], and pressure,
C     P in [PA]:
C          1) Density                           (D)  in [MOL/M3]
C          2) Enthalpy                          (H)  in [J/MOL]
C          3) Entropy                           (S)  in [J/MOL/K]
C          4) Partial Fugacity Coefficient    (FUG)  in [-]
C     based on the B-W-R Han-Sterling EoS, shown in Table 6.7
C
C     - Enthalpy and Entropy are arbitrary assumed to be equal to zero
C       at 273.15 K and 0.1013 MPA.
C     - Perfect-gas properties are calculated from perfect-gas Heat
C       Capacities as: CP=W1+W2*T+W3*(T**2)+W4*(T**3) in [J/MOL/K]
C       where W1=Sum(Xi*Y1i) etc.
C     - Two Switches are required from the subroutine:
C       IP = Phase specification switch (Liquid=1, Vapour=2)
C       IS = Number of components in mixture (Pure fluid=1)
C     - Other data required for each component (I) are:
C       MoleFraction X (-), Critical Temperature, TC in [K], Critical
C       Density in [MOL/M3], and Acentric factor, OMEG.
C     - Binary interaction parameters BK(I,J) must also be specified.
C
      DIMENSION X(IS),TC(IS),DC(IS),OMEG(IS),Y1(IS),Y2(IS),Y3(IS),Y4(IS)
      DIMENSION BK(IS,IS),FUG(IS)
      DIMENSION A0(10),B0(10),C0(10),D0(10),E0(10),AS(10),BS(10),CS(10),
     &DS(10),ALP(10),GAM(10),A(11),B(11)
      DATA A/0.443690,1.28438,0.356306,0.544979,0.528629,0.484011,
     &0.0705233,0.504087,0.0307452,0.0732828,0.006450/
      DATA B/0.115449,-0.920731,1.70871,-0.270896,0.349261,0.754130,
     &-0.044448,1.32245,0.179433,0.463492,-0.022143/
      DATA R,T0,P0/8.314,273.15,0.101325E+6/
C
C     Parameters A0(I),B0(I),C0(I),D0(I),E0(I),
C                AS(I),BS(I),CS(I),DS(I),     &    ALP(I),GAM(I)
C
      DO 100 I=1,IS
      A0(I)=(R*TC(I)/DC(I))*(A(2)+B(2)*OMEG(I))
      B0(I)=(1./DC(I))*(A(1)+B(1)*OMEG(I))
      C0(I)=(R*(TC(I)**3)/DC(I))*(A(3)+B(3)*OMEG(I))
      D0(I)=(R*(TC(I)**4)/DC(I))*(A(9)+B(9)*OMEG(I))
      E0(I)=(R*(TC(I)**5)/DC(I))*(A(11)+B(11)*OMEG(I)*EXP(-3.8*OMEG(I)))
      AS(I)=(R*TC(I)/(DC(I)**2))*(A(6)+B(6)*OMEG(I))
      BS(I)=(1./(DC(I)**2))*(A(5)+B(5)*OMEG(I))
      CS(I)=(R*(TC(I)**3)/(DC(I)**2))*(A(8)+B(8)*OMEG(I))
      DS(I)=(R*(TC(I)**2)/(DC(I)**2))*(A(10)+B(10)*OMEG(I))
      ALP(I)=(1./(DC(I)**3))*(A(7)+B(7)*OMEG(I))
  100 GAM(I)=(1./(DC(I)**2))*(A(4)+B(4)*OMEG(I))
C
C     Total parameters A0T,B0T,C0T,D0T,E0T,
C                      AST,BST,CST,DST,    &  ALPT,GAMT  &  WMOLT
C
      A0T=0.
      B0T=0.
      C0T=0.
      D0T=0.
      E0T=0.
      AST=0.
      BST=0.
      CST=0.
      DST=0.
      ALPT=0.
      GAMT=0.
      WMOLT=0.
      DO 200 I=1,IS
      B0T=B0T+X(I)*B0(I)
      AST=AST+X(I)*(AS(I)**(1./3.))
      BST=BST+X(I)*(BS(I)**(1./3.))
      CST=CST+X(I)*(CS(I)**(1./3.))
      DST=DST+X(I)*(DS(I)**(1./3.))
      ALPT=ALPT+X(I)*(ALP(I)**(1./3.))
      GAMT=GAMT+X(I)*(GAM(I)**(1./2.))
      DO 200 J=1,IS
      BIP=(1.-BK(I,J))
      A0T=A0T+X(I)*X(J)*BIP*((A0(I)*A0(J))**0.5)
      C0T=C0T+X(I)*X(J)*(BIP**3.)*((C0(I)*C0(J))**0.5)
      D0T=D0T+X(I)*X(J)*(BIP**4.)*((D0(I)*D0(J))**0.5)
      E0T=E0T+X(I)*X(J)*(BIP**5.)*((E0(I)*E0(J))**0.5)
  200 CONTINUE
      AST=AST**3
      BST=BST**3
      CST=CST**3
      DST=DST**3
      ALPT=ALPT**3
      GAMT=GAMT**2
C
C     Density calculation
C
      IF (IP.EQ.1) D=100000.
      IF (IP.EQ.2) D=10.
  300 F=-P+(D*R*T)
      F=F+(B0T*R*T-A0T-(C0T/(T**2))+(D0T/(T**3))-(E0T/(T**4)))*D*D
      F=F+(BST*R*T-AST-(DST/T))*(D**3)+ALPT*(AST+(DST/T))*(D**6)
      F=F+(CST/(T**2))*(D**3)*(1.+GAMT*D*D)*EXP(-GAMT*D*D)
      DF=(R*T)+2.*D*(B0T*R*T-A0T-(C0T/(T**2))+(D0T/(T**3))-(E0T/(T**4)))
      DF=DF+3.*D*D*(BST*R*T-AST-(DST/T))
      DF=DF+6.*(D**5)*ALPT*(AST+(DST/T))
      DF=DF+(CST/(T**2))*3.*(D**2)*(1.+GAMT*D*D)*EXP(-GAMT*D*D)
      DF=DF+(CST/(T**2))*(D**3)*(2.*GAMT*D)*EXP(-GAMT*D*D)
      DF=DF-2.*GAMT*D*(CST/(T**2))*(D**3)*(1.+GAMT*D*D)*EXP(-GAMT*D*D)
      H=F/DF
      IF (ABS(H/D).LE.0.000001) GOTO 400
      D=D-H
      GOTO 300
C
C     Perfect-gas Enthalpy & Entropy
C
  400 W1=0.
      W2=0.
      W3=0.
      W4=0.
      DO 500 I=1,IS
      W1=W1+X(I)*Y1(I)
      W2=W2+X(I)*Y2(I)
      W3=W3+X(I)*Y3(I)
  500 W4=W4+X(I)*Y4(I)
      PGH=W1*(T-T0)+W2*((T**2)-(T0**2))/2.+W3*((T**3)-(T0**3))/3.
     &+W4*((T**4)-(T0**4))/4.
      PGS=W1*LOG(T/T0)+W2*(T-T0)+W3*((T**2)-(T0**2))/2.
     &+W4*((T**3)-(T0**3))/3.-R*LOG(P/P0)
C
C     Enthalpy & Entropy
C
      GDD=GAMT*D*D
      H=PGH+D*((B0T*R*T)-(2.*A0T)-(4.*C0T/(T*T))+(5.*D0T/(T**3))-
     &(6.*E0T/(T**4))) + 0.5*(D**2)*(2.*BST*R*T-(3.*AST)-(4.*DST/T))
      H=H + 0.2*(D**5)*ALPT*((6.*AST)+(7.*DST/T))
      H=H + (CST/(GAMT*T*T))*(3.-(3.+0.5*GDD-GDD*GDD)*EXP(-GDD))
      SR=0.
      DO 600 I=1,IS
  600 SR=SR-X(I)*R*LOG(R*T*D*X(I)/P0)
      S=PGS+SR
      S=-D*((B0T*R)+(2.*C0T/(T**3))-(3.*D0T/(T**4))+(4.*E0T/(T**5)))
      S=S - 0.5*(D**2)*((BST*R)+(DST/(T**2)))
      S=S + 0.2*(D**5)*ALPT*DST/(T**2)
      S=S + (2.*CST/(GAMT*(T**3)))*(1.-(1.+0.5*GDD)*EXP(-GDD))
C
C     Partial Fugacities
C
      DO 800 I=1,IS
      FU=(R*T*LOG(D*R*T))+(D*R*T*(B0T+B0(I)))
      FUS=0.
      DO 700 J=1,IS
      BIP=(1.-BK(I,J))
  700 FUS=FUS+X(J)*(-BIP*((A0(J)*A0(I))**0.5)
     &-(BIP**3.)*(((C0(J)*C0(I))**0.5)/(T*T))
     &+(BIP**4.)*(((D0(J)*D0(I))**0.5)/(T**3))
     &-(BIP**5.)*(((E0(J)*E0(I))**0.5)/(T**4)))
      AAI=(AST*AST*AS(I))**(1./3.)
      BBI=(BST*BST*BS(I))**(1./3.)
      CCI=(CST*CST*CS(I))**(1./3.)
      DDI=(DST*DST*DS(I))**(1./3.)
      ALPI=(ALPT*ALPT*ALP(I))**(1./3.)
      GDD=GAMT*D*D
      FU=FU+(2.*D*FUS)+(3.*D*D/2.)*((BBI*R*T)-AAI-(DDI/T))
      FU=FU+(3.*ALPT*(D**5)/5.)*(AAI+(DDI/T))
      FU=FU+(3.*(D**5)/5.)*(AST+(DST/T))*ALPI
      FU=FU+(3.*CCI*D*D/(T**2))*(((1.-EXP(-GDD))/GDD)-(0.5*EXP(-GDD)))
      FU=FU-(2.*CST/(GAMT*T*T))*((GAM(I)/GAMT)**.5)*
     &(1.-(1.+GDD+0.5*GDD*GDD)*EXP(-GDD))
  800 FUG(I)=(1./P)*EXP(FU/(R*T))
      RETURN
      END
